<?php
/*
 * Copyright(C) op5 AB
 * All rights reserved.
 *
 */
/*
 * This file contains wrapper functions to simplify adding
 * support for other database types in the future.
 */

require_once('db_config.inc.php');

// get an error from the last result
function sql_error() {
	global $gui_dbh;
	return(mysql_error($gui_db));
}

// get error number of last result
function sql_errno() {
	global $gui_dbh;
	return(mysql_errno($gui_db));
}

// fetch a single row to indexed array
function sql_fetch_row($resource) {
	return(mysql_fetch_row($resource));
}

// fetch a single row to associative array
function sql_fetch_array($resource) {
	return(mysql_fetch_array($resource, MYSQL_ASSOC));
}

function sql_escape_string($string)
{
	return mysql_real_escape_string($string);
}

// execute an SQL query with error handling
function sql_exec_query($query) {
	global $DEBUG;
	global $gui_dbh;

	if(empty($query)) return(false);

	// workaround for now
	if($gui_dbh === false) {
		gui_db_connect();
	}

	$result = mysql_query($query, $gui_dbh);
	if($result === false) {
		echo "SQL query failed with the following error message;<br />\n" .
		  mysql_error() . "<br />\n";
		if($DEBUG) echo "Query was;<br />\n<b>$query</b><br />\n";
	}

	return($result);
}

// fetch complete results of a query with error checking
// if a table named 'id' exists, resulting array is indexed by it
function sql_fetch_result($resource) {
	global $db_type;
	global $DEBUG;

	$ret = false;
	$id = false;
	$i = 0;

	if(empty($resource)) {
		if($DEBUG) echo "SQL ERROR: sql_fetch_result() called with empty resource\n";
		return(false);
	}

	while($row = sql_fetch_array($resource)) {
		$i++;
		if(isset($row['id'])) {
			$id = $row['id'];
			unset($row['id']);
		}
		else $id = $i;

		if(!empty($row)) {
			foreach($row as $k => $v) {
				if(empty($v) && $v !== 0 && $v !== '0') continue;
				$ret[$id][$k] = $v;
			}
		}
		else {
			$ret[$id] = false;
		}
	}
	return($ret);
}


// connects to and selects database. false on error, true on success
function gui_db_connect() {
	global $gui_dbh;
	global $gui_db_opt;

	if($gui_db_opt['type'] !== 'mysql') {
		die("Only mysql is supported as of yet.<br />\n");
	}

	if(!empty($gui_db_opt['persistent'])) {
		// use persistent connections
		$gui_dbh = mysql_pconnect($gui_db_opt['host'],
								  $gui_db_opt['user'],
								  $gui_db_opt['passwd']);
	}
	else {
		$gui_dbh = mysql_connect($gui_db_opt['host'],
								  $gui_db_opt['user'],
								  $gui_db_opt['passwd']);
	}

	if($gui_dbh === false) return(false);

	return(mysql_select_db($gui_db_opt['database']));
}

// closes the database connection
function gui_db_close() {
	global $gui_dbh;
	global $gui_db_opt;

	if($gui_db_opt['type'] !== 'mysql' || empty($gui_db_opt['persistent'])) {
		return;
	}

	mysql_close($gui_dbh);
}

?>
