<?php
/*
 * Copyright(C) op5 AB
 * All rights reserved.
 */

require_once('config.inc.php');
require_once('object_utils.inc.php');
require_once('db_utils.inc.php');

function crash($msg = false)
{
	if ($msg)
		echo $msg;
	exit(1);
}

function get_set_user_settings() {
	if(!isset($_SERVER['REMOTE_USER'])) return(false);

	$user = $_SERVER['REMOTE_USER'];

	return;
}

// populate the $auth array
$auth = false;
function get_auth_data() {
	global $cgi_config;
	global $main_config;
	global $auth;

	if($auth !== false) {
		return(true);
	}

	if (isset($_SERVER['REMOTE_USER']))
		$user = $_SERVER['REMOTE_USER'];
	else
		$user = get_current_user();

	// check nothing if everything is allowed
	if(in_array($user, $cgi_config['authorized_for_all_hosts']) &&
	   in_array($user, $cgi_config['authorized_for_all_services']))
	{
		$auth = true;
		return(true);
	}
	// Allow wildcard in cgi.cfg (allow for all)
	if(in_array("*", $cgi_config['authorized_for_all_hosts']) &&
	   in_array("*", $cgi_config['authorized_for_all_services']))
	{
		$auth = true;
		return(true);
	}

	// get all the allowed hosts (there is no gain in usging a simpler query)
	$query =
	  ("SELECT DISTINCT host.host_name from host, " .
	   "contact_contactgroup, contact, host_contactgroup " .
	   "WHERE host.id = host_contactgroup.host " .
	   "AND host_contactgroup.contactgroup = contact_contactgroup.contactgroup " .
	   "AND contact_contactgroup.contact = contact.id AND contact.contact_name='" .
	   mysql_escape_string($user) . "'");


	$result = sql_exec_query($query);
	while($row = sql_fetch_row($result)) {
		$auth[$row[0]] = true;
	}

	// same procedure for services
	$query =
	  ('SELECT DISTINCT host.host_name, service.service_description ' .
	   'FROM host, service, contact, contact_contactgroup, service_contactgroup ' .
	   'WHERE service.id = service_contactgroup.service ' .
	   'AND service_contactgroup.contactgroup = contact_contactgroup.contactgroup ' .
	   'AND contact_contactgroup.contact = contact.id AND contact.contact_name = \'' .
	   mysql_escape_string($user) . "' AND host.id = service.host_name");

	$result = sql_exec_query($query);
	while($row = sql_fetch_row($result)) {
		$auth["$row[0];$row[1]"] = true;
	}

	return(true);
}

// reads a configuration file in the format variable=value
// and returns it in an array.
// lines beginning with # are considered to be comments
function parse_config_file($config_file, &$options) {

	$buf = file_get_contents($config_file);
	if($buf === false) return(false);

	$lines = explode("\n", $buf);
	$buf = '';

	$tmp = false;
	foreach($lines as $line) {
		// skip empty lines and non-variables
		$line = trim($line);
		if(!strlen($line) || $line{0} === '#') continue;
		$str = explode('=', $line);
		if(!isset($str[1])) continue;

		// preserve all values if a variable can be specified multiple times
		if(isset($options[$str[0]]) && $options[$str[0]] !== $str[1]) {
			if(!is_array($options[$str[0]])) {
				$tmp = $options[$str[0]];
				$options[$str[0]] = array($tmp);
			}
			$options[$str[0]][] = $str[1];
			continue;
		}
		$options[$str[0]] = $str[1];
	}

	return($options);
}

// calls a couple of necessary functions for GUI operations
// this should be written almost entirely in pseudo-code and only
// evaluate the return code of "real" functions which allows us
// to hack THEM up real quick.
function gui_init($authenticate = true) {
	global $main_config_file;
	global $main_config;
	global $cgi_config_file;
	global $cgi_config;

	if(gui_db_connect() === false) {
		die("Failed to connect to database<br />\n");
	}

	// this should be implemented pretty soon
	$ret = get_set_user_settings();

	// read the necessary config files first
	$ret = parse_config_file($main_config_file, $main_config);
	if($ret === false) {
		crash("Unable to read and parse main configuration file");
	}
	$ret = parse_config_file($cgi_config_file, $cgi_config);
	if($ret === false) {
		crash("Unable to parse GUI configuration file");
	}

	foreach($cgi_config as $k => $v) {
		if(substr($k, 0, 14) === 'authorized_for') {
			$cgi_config[$k] = explode(',', $v);
		}
	}

	// import objects if necessary
	$import_ret = import_objects_if_new_cache();
	if($import_ret === false) {
		crash("Unable to import objects");
	}

	if ($authenticate) {
		$ret = get_auth_data();
		if($ret === false) {
			crash("Failed to read authentication data!<br />\n");
		}
	}

	return($import_ret);
}

// gui cleanup. only close db connection for now (re-hash and re-set cookie
// later, possibly, to avoid cookie theft and such)
function gui_close() {
	gui_db_close();
}

?>
