%define daemon_user monitor
%if 0%{?suse_version}
%define htmlroot /srv/www/htdocs
%define httpconfdir apache2/conf.d
%define daemon_group www
%else
%define htmlroot /var/www/html
%define httpconfdir httpd/conf.d
%define daemon_group apache
%endif
Summary: Web frontend for op5 Monitor
Name: monitor-gui
Version: 3.5.12
Release: op5.1
License: op5 Software License
BuildRoot: %{_tmppath}/%{name}-%{version}
Group: op5/Monitor
URL: http://www.op5.se
Source0: %name-%version.tar.gz
Prefix: /opt/monitor
Requires: monitor, %name-core
Requires: op5common >= 1.1.4
Requires: op5-monitor-supported-webserver
%if 0%{?suse_version}
# SLES-specific stuff
Requires: php53-mysql
%else
# Common RHEL stuff
%if 0%{?rhel} >= 6
Requires: php-mysql
# RHEL6-specific stuff
%else
# RHEL5-specific stuff
%endif
%endif

%description
This package contains the web-based user interface for op5 Monitor.
It provides the basic look and feel by installing custom css files
as well as a menu and some library code that other applications hook
into.

Note that this package doesn't contain any code what so ever that
displays current or historical data collected by the monitor daemon.
The %name-core package is responsible for reading and presenting
collected data in a user-friendly way.


%prep
%setup -q


%install
rm -rf %buildroot

mkdir -p %buildroot%prefix/op5/gui
cp -r share %buildroot%prefix
cp $(find -maxdepth 1 -type f) %buildroot%prefix/op5/gui
cp -r docs %buildroot%prefix/op5/gui
ln -s ../op5 %buildroot%prefix/share/op5
rm -f %buildroot%prefix/{.gitignore,*.spec,*.spec.in}
sed -i 's/^.DEBUG = .*;/$DEBUG = false;/' \
	%buildroot%prefix/op5/gui/config.inc.php

%post
%if 0%{?suse_version}
service apache2 restart || :
%else
service httpd restart || :
%endif
# Verify that mysql-server is installed and running before executing sql scripts
$(mysql -Be "quit" 2>/dev/null)
if [ $? -eq 0 ]; then
  if [ $1 -eq 1 ]; then
	echo "Creating GUI database ... "
	mysqladmin create monitor_gui || :
	mysql -e "GRANT ALL ON monitor_gui.* TO monitor@localhost IDENTIFIED BY 'monitor'"
  fi
  mysql monitor_gui < /opt/monitor/op5/gui/monitor_gui.sql >& /dev/null || :
fi

%postun
if [ $1 -eq 0 ]; then
	echo "Database contains configuration, so not removed."
	echo "If you wish to delete it manually, you will have to do"
	echo
	echo "       mysqladmin drop monitor_gui"
	echo
	echo "which will completely and irrevokably destroy the database."
fi

%files
%defattr(644,root,root,755)
%prefix/share
%prefix/op5/gui

%changelog
* Fri Nov 2 2007 Andreas Ericsson <ae@op5.se>
- Break out monitor-gui from monitor core.
