<?php
/*
 * Copyright(C) op5 AB
 * All rights reserved.
 */

// object relations table. This is used to determine database junction
// table names and such.
$Object_Relation['host'] =
  array('parents' => 'host',
		'check_command' => 'command',
		'notification_period' => 'timeperiod',
		'contacts' => 'contact',
		'contact_groups' => 'contactgroup'
		);

$Object_Relation['hostgroup'] =
  array('members' => 'host');

$Object_Relation['service'] =
  array('host_name' => 'host',
		'contacts' => 'contact',
		'contact_groups' => 'contactgroup',
		'notification_period' => 'timeperiod',
		'check_period' => 'timeperiod',
		'check_command' => 'command'
		);

$Object_Relation['contact'] =
  array('host_notification_period' => 'timeperiod',
		'service_notification_period' => 'timeperiod',
		'host_notification_commands' => 'command',
		'service_notification_commands' => 'command'
		);

$Object_Relation['contactgroup'] =
  array('members' => 'contact');

$Object_Relation['servicedependency'] =
  array('host_name' => 'host',
		'dependent_host_name' => 'host',
		'dependency_period' => 'timeperiod',
		);

$Object_Relation['serviceescalation'] =
  array('host_name' => 'host',
		'contacts' => 'contact',
		'contact_groups' => 'contactgroup',
		'escalation_period' => 'timeperiod',
		);

$Object_Relation['servicegroup'] =
  array('members' => 'service');

$Object_Relation['hostdependency'] =
  array('host_name' => 'host',
		'dependent_host_name' => 'host',
		'dependency_period' => 'timeperiod');

$Object_Relation['hostescalation'] =
  array('host_name' => 'host',
		'contact_groups' => 'contactgroup',
		'escalation_period' => 'timeperiod',
		'contacts' => 'contact',
		'contact_groups' => 'contactgroup',
		);

$Object_Relation['timeperiod'] =
	array('exclude' => 'timeperiod');
?>
