<?php
/*
 * Copyright(C) op5 AB
 * All rights reserved.
 */

define('SHA_HEADER', '{SHA}');
define('MD5_HEADER', '$apr1$');

function html_end() {
	$args = func_get_args();
	foreach($args as $arg) {
		echo "$arg<br />\n";
	}

	echo "</body></html>\n";
	exit;
}

# in case we're using basic auth (the default) and the user just
# changed his/her password, we'll get one password dialog box for
# every stylesheet we try to load, so we'll have to make do with
# just one
echo "<html><head><title>Password change for op5 Monitor GUI access</title>";
echo "<link rel='stylesheet' type='text/css' href='/monitor/stylesheets/common.css' />\n";
echo "<link rel='stylesheet' type='text/css' href='/monitor/css/response.css' />\n";
echo "<link rel='stylesheet' type='text/css' href='/monitor/css/form.css' />\n";
echo "</head><body>\n";


if(empty($_SERVER['REMOTE_USER'])) {
	html_end("No user logged in");
}

$user = $_SERVER['REMOTE_USER'];

function passwd_dialog() {

	$args = func_get_args();

	echo "<div style='color: red'>";
	foreach($args as $arg) {
		echo "$arg<br />\n";
	}
	echo "</div>";

    $user = $_SERVER['REMOTE_USER'];
    $date_str = date('D M d h:i:s T Y');
	echo <<<EOHTML

	<!--<table class='infoBox'>
		<tr>
			<td>
				<div class='infoBoxTitle'>op5 Monitor Password Changer</div>
				Last Updated: $date_str<br />
				Logged in as <i>$user</i><br />
			</td>
		</tr>
	</table>
	<br />-->
	<div id="response"><ul class="warning"><li><div style="margin:5px 0px 10px 0px">Note that changing the password will log you out.</div></li></ul></div>

	<form method="post" action="{$_SERVER['PHP_SELF']}">
		<table>
			<tr class="command">
				<td colspan="2" class="pwd_subtitle"><br />Enter your current password</td>
			</tr>
			<tr>
				<td>Current password:</td>
				<td><input type="password" name="old_p" maxlength="25"></td>
			</tr>
			<tr class="command">
				<td colspan="2" class="pwd_subtitle"><br />Enter your new password</td>
			</tr><tr>
				<td>New password:</td>
				<td><input type="password" name="p1" maxlength="25"></td>
			</tr><tr>
				<td>Retype password:</td>
				<td><input type="password" name="p2" maxlength="25"></td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td><input type="submit" name="go" value="&nbsp;" class="button submit"></td>
			</tr>
		</table>
	</form>

EOHTML;

	html_end();
}

if(!isset($_POST['p1']) && !isset($_POST['p2'])) passwd_dialog();

$pw = false;
$p1 = false;
$p2 = false;

$old_p = $_POST['old_p'];
$p1 = $_POST['p1'];
$p2 = $_POST['p2'];

if(empty($old_p))
  passwd_dialog("Old password cannot be empty\n");

if(empty($p1) || empty($p2))
  passwd_dialog("Empty passwords aren't allowed\n");

if($p1 !== $p2)
  passwd_dialog("Passwords don't match<br />\n");

$htpasswd_users_contents = file_get_contents('/opt/monitor/etc/htpasswd.users');
if(empty($htpasswd_users_contents))
{
	passwd_dialog("Could not authenticate current user. Missing password file.");
	exit;
}

$old_passwords_match = false;
$user = $_SERVER['REMOTE_USER'];

$htpasswd_rows = explode("\n", $htpasswd_users_contents);
$print_wrong_old_pass = true;
$num_htpasswd_rows = count($htpasswd_rows);

for($i=0 ; $i<$num_htpasswd_rows ; $i++)
{
	$row =& $htpasswd_rows[$i];

	if(strpos($row, $user) === 0)
	{
		$row = substr($row, strlen($user) + 1);
		if(strpos($row, SHA_HEADER) === 0)
		{
			$shasum = substr($row, strlen(SHA_HEADER));
			if(base64_encode(sha1($old_p,true)) === $shasum)
				$old_passwords_match = true;
		}
		elseif(strpos($row, MD5_HEADER) === 0)
		{
			$salt = substr($row, strlen(MD5_HEADER));
			$salt = substr($salt, 0, strpos($salt, '$'));
			if(strlen($salt) > 8)
			{
				passwd_dialog("Stored password is malformed, could not authenticate<br>");
				exit;
			}

			$msg = $ret = null;
			$last_msg = exec('which openssl', $msg, $ret);
			if($ret !== 0)
			{
				passwd_dialog("openssl utility is missing - needed to check old md5 encrypted passwords<br>Please install the openssl command line utility.<br>");
				exit;
			}

			# TODO: should this command use previously fetched absolute path to binary?
			$cmd = "openssl passwd -apr1 -salt $salt $old_p 2>&1";
			$msg = $ret = null;
			$last_msg = exec($cmd, $msg, $ret);

			if($ret !== 0) {
				passwd_dialog("Failed to encrypt old pass using md5\n");
				exit;
			}

			if($msg[0] === $row)
				$old_passwords_match = true;
		}
		break;
	}
}

if(!$old_passwords_match && $print_wrong_old_pass)
{
	passwd_dialog("Wrong current password entered");
	exit;
}

// p1 == p2, so reset the password
$pw = escapeshellarg($p1);
$msg = $ret = false;

$cmd = "/usr/bin/htpasswd -s -b /opt/monitor/etc/htpasswd.users $user $pw 2>&1";
$last_msg = exec($cmd, $msg, $ret);
if($ret !== 0) {
	echo "Password change failed.<br />\n";
	echo "Please contact
		   <a href='mailto:support@op5.se?subject=Password change fails'>
		   support@op5.se</a> regarding this matter<br />\n";
	echo "Please make sure to include the message below.<br />\n";
	echo "<pre>\n"; print_r($msg); echo "</pre>\n";
}

echo "$last_msg<br />\n";

html_end();
?>
