<?php
/*
 * Copyright(C) op5 AB
 * All rights reserved.
 */

require_once('config.inc.php');

function is_authorized($obj_name)
{
	global $auth;

	if (!is_array($auth))
		return $auth;

	return isset($auth[$obj_name]);
}

# populate the $status array with objects the user is allowed to see
function get_current_status() {
	global $main_config;
	global $status;

	if(!is_file($main_config['status_file'])) {
		return(false);
	}

	$obj_type = false;
	$obj = false;
	$fh = fopen($main_config['status_file'], "r");
	if (!$fh)
		return false;

	while (!feof($fh)) {
		$line = trim(fgets($fh));

		if (!$line || $line{0} === '#')
			continue;

		if(!$obj_type) {
			$str = explode(' ', $line);
			if($str[1] !== '{') continue;

			$obj_type = $str[0];
			switch ($obj_type) {
			 case 'host': case 'hoststatus':
				$obj_type = 'host';
				break;
			 case 'service': case 'servicestatus':
				$obj_type = 'service';
				break;
			}
			continue;
		}


		if($line === '}') {
			if(!isset($obj['host_name'])) {
				$obj_type = false;
				$obj = false;
				continue;
			}

			$host = $obj_name = $obj['host_name'];
			if ($obj_type === 'service')
				$obj_name .= ';' . $obj['service_description'];

			if (is_authorized($obj_name)) {
				$status[$obj_type][$obj_name] = $obj;

				# services get double-indexed, so set a
				# reference here so we save some memory
				if ($obj_type === 'service') {
					$status[$obj_type][$host][$obj['service_description']] =
						&$status[$obj_type][$obj_name];
				}
			}

			$obj_type = $obj = false;
			continue;
		}

		if ($obj_type !== 'host' && $obj_type !== 'service')
			continue;

		$str = explode('=', $line, 2);

		$k = $str[0]; $v = $str[1];
		if ($k === 'host_name' || $k === 'service_description') {
			$obj[$k] = $v;
			continue;
		}
		if (strpos($k, 'state')) {
			$obj[$k] = $v;
			continue;
		}
	}
}

// NOT USED!
// read status
function get_host_status(&$status_array) {
	$lines = explode("\n", file_get_contents(STATUS_LOG_FILE));

	$in_obj = $tmp_ary = $obj_type = $obj_index = false;
	foreach($lines as $line) {
		$line = trim($line);
		if(!strlen($line) || $line{0} === '#') continue;
		if(!$in_obj) {
			$str = explode(' ', $line, 2);
			$obj_type = $str[0];
			if($str[1] === '{') {
				$in_obj = true;
				if(!isset($obj_index[$obj_type])) $obj_index[$obj_type] = 0;
				else $obj_index[$obj_type]++;
			}
			continue;
		}

		if($line === '}') {
			$in_obj = false;
			continue;
		}
		$str = explode('=', $line, 2);
		$tmp_ary[$obj_type][$obj_index[$obj_type]][$str[0]] = $str[1];
	}

	$srv_status_list = array('0' => 'ok',
							 '1' => 'warning',
							 '2' => 'critical',
							 '3' => 'unknown');
	$host_ary = false;
	foreach($tmp_ary as $obj_type => $obj_list) {
		if($obj_type !== 'host' && $obj_type !== 'service') {
			continue;
		}

		foreach($obj_list as $obj_key => $obj) {
			if(!isset($obj['host_name'])) continue;
			if($obj_type === 'host') {
				$host_ary[$obj['host_name']]['status'] = $obj['current_state'];
				foreach($srv_status_list as $str) {
					$host_ary[$obj['host_name']][$str] = 0;
				}
			}
			elseif($obj_type === 'service') {
				$str = $srv_status_list[$obj['current_state']];
				$host_ary[$obj['host_name']][$str]++;
			}
		}
	}

	$status_array = $host_ary;
	$_SESSION['last_log_read'] = filemtime(STATUS_LOG_FILE);
}


function read_cfg_setting($setting_name, $cfg_file) {
	$setting_len = strlen($setting_name);
	$buf = read_file ($cfg_file);
	$lines = explode ("\n", $buf);
	foreach($lines as $line) {
		$line = trim($line);
		if(!empty($line)) {
			if ($line{0} === '#') continue;
			$in_line = strpos($line, $setting_name);
			if ($in_line === 0) {
				$setting_value = split ("=", $line, 2);
				return(trim($setting_value[1]));
			}
		}
	}
}

?>
