<?php
$license_checks_out = false;
$bundle = false;
$body_onload = NULL;
$version = $release = $username = '?';
if (isset($_SERVER['REMOTE_USER']))
	$username = $_SERVER['REMOTE_USER'];

if (is_readable('/opt/op5sys/lib/php/op5license.php')) {
	require_once('/opt/op5sys/lib/php/op5license.php');

	$license = new op5license();
	$license->register_product('Monitor');
	$license->check();

	# check monitor version
	$err = false;
	$arr = array();
	$rpm_cmd = 'rpm -q op5-monitor-release --queryformat="%{version}\n%{release}\n"';
	$release = '';
    if (file_exists("/bin/rpm")){
	exec($rpm_cmd, $arr, $err);
	if ($err !== 0) {
		$version = "BETA";
		$release = '';
	} else {
		$version = trim($arr[0]);
		if ($arr[1] !== 'op5.1')
			$release = ' ' . $arr[1];
	}
    } else {
	$dpkg_cmd="dpkg-query -W op5-monitor-release | awk '{print$2}'";
	exec($dpkg_cmd, $arr, $err);
	if ($err !== 0) {
	    $version = "BETA";
	    $release = '';
	} else {
	    $arr=explode("-", $arr[0]);
	    $version=$arr[0];
	    if ($arr[1] !== 'op5.1')
	      $release = ' ' . $arr[1];
	}
    }
}

$page = isset($_GET['page']) ? $_GET['page'] : 'Tactical Overview';

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	<head>
		<meta http-equiv="content-type" content="application/xhtml+xml; charset=iso-8859-1" />
		<meta http-equiv="Pragma" content="no-cache" />
		<meta http-equiv="Pragma-directive" content="no-cache" />
		<meta http-equiv="Cache-directive" content="no-cache" />
		<meta http-equiv="Expires" content="0" />
		<meta http-equiv="refresh" content="90" />
		<title> op5 Monitor &raquo; Menu </title>
		<link type="text/css" rel="stylesheet" href="/monitor/css/common.css" />
		<link type="text/css" rel="stylesheet" href="/monitor/css/gui.css" />
	</head>

	<body class="top">
		<div id="logo">
			<img src="/op5common/includes/text_to_image.php?text=<?php echo (!empty($bundle) ? $bundle : '_'); ?>" style="margin-top: 11px; margin-left: 183px" />
		</div>
		<div id="navbar">
			<h1><?php echo str_replace('_',' ',$page); ?></h1>
			op5 Monitor <img src="/monitor/images/icons/arrows/red.gif" alt="&raquo;" />
			<?php echo str_replace('_',' ',$page); ?>
		</div>

		<div id="info">
			<!--Powered by Nagios®<br />-->
			Logged in to op5 Monitor <em><?php echo "$version$release</em> as user <em>$username"; ?></em><br />
			Last updated: <em><?php echo date('d M H:i:s T Y') ?></em><br />

		</div>

		<div id="reload">
			<a href="#" onclick="parent.main.location.reload(); location.reload(); return false"><img src="/monitor/images/icons/32x32/reload.png" alt="Reload current page" /></a>
		</div>
	</body>
</html>
