<?php

require_once('/opt/monitor/op5/nacoma/include/webconfig.inc.php');


$module_enabled="broker_module=/opt/monitor/op5/merlin/merlin.so";
$nagios_cfg="/opt/monitor/etc/nagios.cfg";
$nagios_cmdpipe="/opt/monitor/var/rw/nagios.cmd";
$enabled = false;

# Check if broker_module is enabled
exec("grep ^broker_module=/opt/monitor/op5/merlin/merlin.so $nagios_cfg", $out, $retval);
if($retval === 0)
  $enabled = true;

# User is not 'super user' we return here so that the enable/disable links are not shown.
if(!is_super_user())
  return;

# Tmp file used to edit nagios.cfg
$tmpfname = tempnam("/tmp", "merlin");


# If we get a request to modify merlin state we check it
if(isset($_REQUEST['merlin'])){
    $now = time();

    # If we try to disable the module _and_ it is currently enabled we edit nagios.cfg and restart monitor
    if($_REQUEST['merlin'] === "disable" && $enabled) {
	$res = exec("sed 's/^broker_module=\/opt\/monitor\/op5\/merlin\/merlin.so/# broker_module=\/opt\/monitor\/op5\/merlin\/merlin.so/' $nagios_cfg > $tmpfname", $out, $retval);
	rename($tmpfname, $nagios_cfg);
	file_put_contents($nagios_cmdpipe, "[$now] RESTART_PROGRAM;$now\n");
    }

    # If we try to enable the module _and_ it is currently disabled we edit nagios.cfg and restart monitor
    if($_REQUEST['merlin'] === "enable" && ! $enabled) {
	exec("sed 's/^#[ \t]*broker_module=\/opt\/monitor\/op5\/merlin\/merlin.so/broker_module=\/opt\/monitor\/op5\/merlin\/merlin.so/' $nagios_cfg > $tmpfname", $out, $retval);
	rename($tmpfname, $nagios_cfg);
	file_put_contents($nagios_cmdpipe, "[$now] RESTART_PROGRAM;$now\n");
    }
}

# remove the temp file
unlink($tmpfname);

$test = exec("grep ^$module_enabled $nagios_cfg", $out, $retval);

$state = $retval === 0 ? 'enabled' : 'disabled';
$toggle = $retval === 0 ? 'disable' : 'enable';
# Print link to enable/disable the merlin module
$msg = "The Merlin module required by the Ninja interface is $state. If you for some reason want to $toggle Merlin use the link below.<br />" .
	"More information about Merlin is available at <a href=\"http://www.op5.org/community/projects/merlin/\" target=\"_blank\">http://www.op5.org</a><br /><br />\n";
if ($retval === 0 ){
	echo $msg;
	echo "<img id=\"merlinok\" src=\"/ninja/application/views/themes/default/icons/16x16/stop-execute.png\" />";
	echo "<a href='about.php?merlin=disable'> Disable Merlin </a>";
} else {
	echo "<stong><b>NOTE:</b></strong> $msg<br>";
	echo "<img id=\"merlinnotok\" src=\"/ninja/application/views/themes/default/icons/16x16/start.png\" />";
	echo "<a href='about.php?merlin=enable'> Enable Merlin </a>";
}

?>
